#include <Arduino.h>
#include <SIM800GSM.hpp>
#include <SIM800HostCommunication.hpp>

SIM800GSM::SIM800GSM() : host()
{
    host.begin(9600);
}

bool SIM800GSM::Call (String Number)
{
	return host.checkResponce (host.writeCommand("ATD"+Number+";\r", 1000));
}

bool SIM800GSM::HangUp (void)
{
	return host.checkResponce (host.writeCommand("ATH\r", 1000));
}

bool SIM800GSM::SendSMS (String Number, String Text)
{
	Text = Text + "\032";	// CTRL+Z

	if (!host.checkResponce(host.writeCommand("AT+CMGF=1\r", 1000)))
		return false;

	if (!host.checkResponce(host.writeCommand("AT+CSCS=\"GSM\"\r", 1000)))
		return false;

	host.writeCommand("AT+CMGS=\""+Number+"\"\r", 1000);

	host.writeCommand(Text, 1000);
	return true;
}

bool SIM800GSM::ReadSMS (char Index[])
{
	String Temp = Index;
	host.write("AT+CMGF=1\r");
	delay (100);
	host.write("AT+CMGR="+Temp+'\r');
	return true;
}

bool SIM800GSM::ReadAllSMS ()
{
	host.write("AT+CMGF=1\r");
	delay (100);
	host.write("AT+CMGL=\"ALL\"\r");
	return true;
}

bool SIM800GSM::CallerIDVisible (bool Val)
{
	if (Val)
		host.write("AT+CLIP=1\r");
	else
		host.write("AT+CLIP=0\r");

	return true;
}


bool SIM800GSM::GetCallerID (char CallerID[])
{
	int Index=1;
	bool StartFlag = false, EndFlag = false;
	char C;

	while (1)
	{
		if (Serial1.available () == 0)
			continue;
		if (EndFlag)
		{
			while (Serial1.available () > 0)
				C = Serial1.read ();
			break;
		}

		C = Serial1.read ();
		Serial.print (C);
		if (StartFlag && !EndFlag)
			CallerID[Index++] = C;
		if (C=='"')
		{
			if (StartFlag == false)
				StartFlag = true;
			else
				EndFlag = true;
		}
	}
	CallerID[Index-1] = 0;	// last character will be '"' and must be ignored
	return true;
}
