#include <SIM800.h>

#define __PWRKEY__ 11
#define __RESET__ 12

SIM800Core  core;
SIM800GSM GSM800;

char Choice, Number[11], Message [64];

void ReadString (char Str[])
{
  int i=0;
  char Dummy;
  // clear the leftovers of \r \n and other symbols like them
  while (Serial.available () > 0)
    Dummy = Serial.read ();
  while (1)
  {
    if (Serial.available () > 0)
    {
      Str[i] = Serial.read ();
      if (Str[i] == '\r' || Str[i] == '\n')
        break;
      i++;
    }
  }
  Str[i] = 0;
}

void setup()
{
  Serial.begin(9600);
  Serial1.begin(9600);

  core.host.echo(false);
}

void loop ()
{
  // Detecting incoming calls and messages
  if (Serial1.available () > 0)
    Serial.print((char)Serial1.read());

  if (Serial.available () > 0)
  {
    Serial.println ();
    Serial.println ("1. Call");
    Serial.println ("2. Hang up");
    Serial.println ("3. Send SMS");
    Serial.println ("4. Read SMS");
    Serial.println ("5. Read all SMS");
    Choice = Serial.read ();  // make your choice which of the options do you want
    if (Choice == '\r' || Choice == '\n')  // ignore line ending characters
      return;

    switch (Choice)
    {
      // Call
      case '1':
        Serial.print ("\nInput number: ");
        ReadString (Number);
        if (GSM800.Call (Number))
          Serial.println ("\nCalling in progress!");
        else
          Serial.println ("\nError!");
      break;

      // Hang up
      case '2':
        if (GSM800.HangUp ())
          Serial.println ("\nHang up!");
        else
          Serial.println ("\nError!");
      break;

      // Sending SMS
      case '3':
        Serial.print ("\nInput number: ");
        ReadString (Number);
        Serial.print ("\nInput message: ");
        ReadString (Message);

        if (GSM800.SendSMS (Number, Message))
          Serial.println ("\nSMS Sent!");
        else
          Serial.println ("\nError!");
      break;

      // Reading SMS
      case '4':
        char Index[4];  // 3 digits and \0 ==> max index value = 999
        Serial.print ("Input the index of the SMS you want to read: ");
        ReadString(Index);
        Serial.println ("\nPress SPACE to proceed after listing!");
        GSM800.ReadSMS (Index);
        while (Serial.read ()!=' ')
          while (Serial1.available()>0)
            Serial.print ((char)Serial1.read());
      break;

      // Reading all SMS
      case '5':
        Serial.println ("\nPress SPACE to show the SMS text and then SPACE again to proceed!");
        while (Serial.read ()!=' ');
        GSM800.ReadAllSMS ();
        while (Serial.read ()!=' ')
          while (Serial1.available()>0)
            Serial.print ((char)Serial1.read());
      break;
    }
  }
}

